// Stay
// written by TheSnowyOwl
//
// alarmanalog (analog-alarm-clock.wav) from www.freesound.org, by bone666138
// alarmclock (alarm-clock-short.wav) from www.freesound.org, by zyrytsounds
// alarmbell (b15.bell.mp3) from www.freesound.org, by danarobinsondesignsgmailcom
// alarmchime (chime2.wav) from www.freesound.org, by neotone
// alarm4tone (4-tone-chime-up.wav) from www.freesound.org, by mpaol2023
// alarmbeep (beep4.wav) from www.freesound.org, by thisusernameis
/*
 * Resources
 * scripts/TheSnowyOwl/Stay.groovy
 * sounds/TheSnowyOwl/alarm*.*
 * images/TheSnowyOwl/TheSnowyOwl.png
 * images/TheSnowyOwl/TheRedOwl.png
 * images/TheSnowyOwl/stay*.jpg
 * images/TheSnowyOwl/lap2*.jpg
 * images/TheSnowyOwl/lap3*.jpg
 * images/TheSnowyOwl/exit*.jpg
*/

def titleline="Stay"
def version="v2.1"
def optdom=1==loadInteger("TheSnowyOwl.Stay.opt.dom")
setInfos(9, titleline,
	"Stand/Kneel/etc in the corner or other assigned position and location until released. Failure is punished with a spanking.",
	"TheSnowyOwl", version, optdom ? 0xFFC0C0 : 0xE0F0FF, "en",
	["spanking", "femaledomoption", "forfemale", "formale", "game"])
def titleplus=titleline
def myname="Stay"
def properties="TheSnowyOwl."+myname+"."

def debugtext=false // Manually set to true to validate text
def debugmode=false // Manually set to true to test without waiting
def debugrand=false // Manually set to true to debug random arrays

def getstayfile =
{ khost ->
	if (khost < 100)
		return ("TheSnowyOwl/stay"+khost+".jpg")
	else
		return ("TheSnowyOwl/stay"+(khost-100)+"m.jpg")
}

def getlapfile =
{ khost ->
	return ("TheSnowyOwl/lap"+khost+".jpg")
}

def gethostfile =
{ khost ->
	if (optdom)
		return getlapfile(khost)
	else
		return getstayfile(khost)
}

def TheOwl= {
	return ("TheSnowyOwl/The"+(optdom?"Red":"Snowy")+"Owl.png")
}

///////////////////////////////////////////////////////////////////////////////
// Common Library v1.3

def rerun="TheSnowyOwl/"+myname

// No nulls
def loadBooleanVal = { keyword1, defaultval ->
	def ret=loadBoolean(keyword1)
	if (ret == null)
		return defaultval
	else
		return ret
}

def loadIntegerVal = { keyword1, defaultval ->
	def ret=loadInteger(keyword1)
	if (ret == null)
		return defaultval
	else
		return ret
}

def loadStringVal = { keyword1, defaultval ->
	def ret=loadString(keyword1)
	if (ret == null)
		return defaultval
	else
		return ret
}

// Player
def female=loadBooleanVal("intro.female", false)
def likefemale=loadBooleanVal("intro.likefemale", true)
def likemale=loadBooleanVal("intro.likemale", true)
def like=1		// 0=likemale, 1=likefemale, 2=both
if (likemale)
{
	if (likefemale)
		like=2
	else
		like=0
}

// Rotating Opponent (Host)
def host=[]
def nhost=0
def yourhost=1
def imagefile=""
def instructimagefile=""
def configimagefile=""

def shuffle = { deck, ndeck ->
	def newdeck=[]
	for (def i=0 ; i<ndeck ; i++)
		newdeck[i]=deck[i]
	for (def i=0 ; i<ndeck ; i++)
	{
		def j=getRandom(ndeck)
		def temp=newdeck[i]
		newdeck[i]=newdeck[j]
		newdeck[j]=temp
	}
	return newdeck
}

def newdeck =
{ low, high ->
	def deck=[]
	for (def i=low ; i<=high ; i++)
		deck[i-low]=i
	return shuffle(deck, high-low+1)
}

def joindeck =
{ deck1, ndeck1, deck2, ndeck2 ->
	def join=[]
	for (def i=0 ; i<ndeck1 ; i++)
		join[i]=deck1[i]
	for (def i=0 ; i<ndeck2 ; i++)
		join[i+ndeck1]=deck2[i]
	return shuffle(join, ndeck1+ndeck2)
}

def gethost =
{
	yourhost++
	return (gethostfile(host[yourhost%nhost]))
}

def select=
{msg, buttons, on, nbuttons ->
	def asklabel=[]
	def askans=[]
	def nask=0
	for (def i=0 ; i<nbuttons ; i++)
	{
		if (on[i])
		{
			asklabel[nask]=buttons[i]
			askans[nask]=i
			nask++
		}
	}
	def ans=getSelectedValue(msg, asklabel)
	return askans[ans]
}

// return: 0=Previous, 1=Next, 2=Exit
def prevnext = {msg, prev, next, exit ->
	def label=["< Previous", "Next >"]
	label[2]=exit
	def on=[true,true,true]
	on[0]=prev
	on[1]=next
	def ans=select(msg, label, on, 3)
	return ans
}

def testexists={ filename ->
	File x = new File(filename)
	return (x.exists())
}

def unit={numb, singular, plural ->
	def val=numb
	if (val == (int)(val))
		val=(int)(val)
	if (val == 1)
		return (val+" "+singular)
	else
		return (val+" "+plural)
}

def initshare=
{includeme, type ->
	def share="0"
	def next="0"
	def found=false
	if (!includeme)
		found=true
	for (def i=0 ; next != null ; i++)
	{
		next=loadString("TheSnowyOwl.All."+type+i)
		if (next == null)
		{
			if (!found)
			{
				save("TheSnowyOwl.All."+type+i, titleline)
				save("TheSnowyOwl.All."+type+i+"file", myname)
				save("TheSnowyOwl.All."+type+(i+1), null)
			}
		}
		else if (next == titleline)
			found=true
		else if (share == "0")
			share=next
		else
			share+=", "+next
	}
	return share
}

def atleast =
{msg1, curval, minval, maxval ->
	def running=true
	def ans
	for ( ; running ; )
	{
		ans=getInteger(msg1, curval)
		if (ans >= minval)
		{
			if (ans <= maxval | maxval <= 0)
				running=false
			else
				showPopup("Value cannot be greater than "+maxval)
		}
		else
			showPopup("Value must be at least "+minval)
	}
	return ans
}

def asker =
{msg1, curval, minval, maxval, defval ->
	def msg=msg1
	if (curval != defval)
		msg+="\nDefault value is "+defval+"."
	def ans=atleast(msg, curval, minval, maxval)
	return ans
}

def exitdoor=
{ played ->
	def numb=played%4-1
	if (numb < 0)
		return "door.jpg"
	else
		return ("TheSnowyOwl/door"+numb+".png")
}

///////////////////////////////////////////////////////////////////////////////
// Clothes B Library v1.0

def clothes = []
def clotheson = [true, true, true, true, true, true]
if (female)
{
	clothes[0]="Top"
	clothes[1]="Bra"
	clothes[2]="Skirt/Pants"
	clothes[3]="Undies"
	clothes[4]="Shoes"
	clothes[5]="Socks"
}
else
{
	clothes[0]="Shirt"
	clothes[1]="Undershirt"
	clothes[2]="Pants"
	clothes[3]="Underware"
	clothes[4]="Shoes"
	clothes[5]="Socks"
}

///////////////////////////////////////////////////////////////////////////////
// Implements Library v1.0

// Following 2 lists extracted from system/implements.groovy written by Banjo
def items = ["hairbrush", "hairbrush_plastic", "hairbrush_paddle", "bathbrush", 
		"wooden_spoon", "spatula", "spatula_wooden", "ruler", "flyswatter", 
		"bat", "bat_flyback", "bat_jokari", "bat_beach", 
		"slipper", "plimsoll", "sandal", "sneaker", 
		"paddle", "paddle_holes", "paddle_lexan", "paddle_plastic", 
		"paddle_leather", "paddle_rubber", "slapper", 
		"belt", "strap", "strap_studded", "strap_loop", "tawse", 
		"crop", "martinet", "flogger", "cat_o_nine", "whip", "penis_whip", 
		"cane", "cane_heavy", "cane_otk", "cane_loop", "cane_plastic",
		"rod", "duster", "switch", "birch"];
def names = ["hairbrush", "plastic hairbrush", "paddle hairbrush", "bathbrush", 
		"wooden spoon", "rubber spatula", "wooden spatula", "ruler", "flyswatter", 
		"table tennis bat", "paddleball bat", "battledore bat", "beach tennis bat", 
		"slipper", "plimsoll", "sandal", "sneaker", 
		"wooden paddle", "paddle with holes", "lexan paddle", "plastic paddle", 
		"leather paddle", "rubber paddle", "leather slapper",
		"belt", "strap", "studded strap", "loop strap", "tawse", 
		"riding crop", "martinet", "flogger", "cat-o-nine-tails", "whip", "penis whip", 
		"light cane", "heavy cane", "short cane", "loop cane", "plastic cane", 
		"curtain rod", "duster handle", "switch", "birch rod"];
def impvalid=[]
def imp=[]
def nimp
def imprandom
def impdefault
def impshare="0"

def initimp=
{includeme ->
	nimp=0
	for (def i=0 ; items[i] != null ; i++)
	{
		impvalid[i]=loadBooleanVal("toys."+items[i], false)
		if (impvalid[i])
		{
			imp[nimp]=names[i]
			nimp++
		}
	}
	imp=shuffle(imp,nimp)
	imprandom=loadBooleanVal("TheSnowyOwl.All.imprandom", false)
	impdefault=loadStringVal("TheSnowyOwl.All.impdefault", "paddle")
	if (nimp == 0)
		imprandom=false
	impshare=initshare(includeme,"impshare")
}

def impconfig=
{
	show(" ")
	def msg="<b>Implements</b>\n\n"
	msg+="Spanking will be done with "
	if (imprandom)
	{
		msg+="an implement selected at random from those that you own. "
		msg+="To change this list, click Modify List. "
		msg+="To use an implement of your choice, click Select.\n\n"
	}
	else
	{
		msg+="the "+impdefault+".  To change this, click Select. "
		msg+="To have the implement be randomly selected "
		msg+="from those that you own, click Modify List.\n\n"
	}
	if (impshare != "0")
	{
		def andback=impshare
		if (impshare.length() > 40)
			andback="these scripts"
		msg+="The list of implements and the decision to select an "
		msg+="implement or have it selected at random will be copied to "+impshare
		msg+=" and any changes made in "+andback+" will be copied to this script.\n\n"
		msg+="In addition, changes "
	}
	else
		msg+="Changes "
	msg+="to the list of implements will be copied to GameHub (written by Banjo) "
	msg+="and changes in GameHub will be copied to this script."
	def button=getSelectedValue(msg, ["Select", "Modify List", "Exit Config"])
	if (button == 0)
	{
		impdefault=getString("What implement should be used?", impdefault)
		impdefault=impdefault.trim()
		if (impdefault.length() == 0)
			impdefault=null
		save("TheSnowyOwl.All.impdefault",impdefault)
		save("TheSnowyOwl.All.imprandom",false)
		initimp(true)
	}
	else if (button == 1)
	{
		show(" ")
		def impnew=getBooleans("What implements do you own?", names, impvalid)
		if (impnew != null)
		{
			show("List being saved")
			for (def i=0 ; items[i] != null ; i++)
				save("toys."+items[i], impnew[i])
			save("TheSnowyOwl.All.imprandom", true)
		}
		initimp(true)
	}
}

///////////////////////////////////////////////////////////////////////////////
// SpankMe Library v2.0

def spankme=
{ count, implement, say ->
	def msg="Get the "+implement+".\nGet in position.\n"
	msg+=unit(count,"Spank","Spanks")+" will be counted out for you.\n"
	msg+="Alternate cheeks.\nBegin after pressing the button."
	show(msg)
	showButton("I am ready to begin my spanking")
	show(" ")
	wait(2)
	def time=3.0
	for (def i=1 ; i<=count ; i++)
	{
		show("<font size=30>&nbsp;&nbsp;"+i)
		playBackgroundSound("swat.wav")
		if (say == null)
		{
			wait(time)
			time=1.6
		}
		else
		{
			wait(1)
			show("<font size=30>&nbsp;&nbsp;"+i+"&nbsp;&nbsp;"+say)
			wait(3)
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Alarm Library V1.1

def alarmnum
def alarmlist=["analog", "clock", "bell", "chime", "4tone", "beep"]
def alarmdesc=["Analog Alarm Clock", "Digital Alarm Clock",
	"Bell", "Chime", "4 Tones", "Beep"]
def nalarm=6

def initalarm=
{
	def alarm=loadString(properties+"alarm")
	for (alarmnum=0 ; alarmnum<nalarm ; alarmnum++)
	{
		if (alarm == alarmlist[alarmnum])
			return
	}
	alarmnum=0
}

def ringalarm={
	def alarm=alarmlist[alarmnum]
	if (alarm == "bell")
		playBackgroundSound("TheSnowyOwl/alarm"+alarm+".mp3")
	else
		playBackgroundSound("TheSnowyOwl/alarm"+alarm+".wav")
}

def testalarm={
	for ( ; ; )
	{
		show("Testing "+alarmdesc[alarmnum]+" ...")
		ringalarm()
		wait(2)
		def msg="If you did not hear the "
		msg+=alarmdesc[alarmnum]+", adjust the equipment and test again. "
		msg+="If you would like a different type of alarm, click change. "
		msg+="If satisfied, click continue."
		def button=getSelectedValue(msg, ["Test Again", "Change", "Continue"])
		if (button == 2)
			return
		if (button == 1)
		{
			alarmnum=getSelectedValue("Select an Alarm", alarmdesc)
			save(properties+"alarm",alarmlist[alarmnum])
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// @ Initialize

def stay=[]
def nstay=0
def yourstay=1
def lap=[]
def nlap=0
def yourlap=1
def pointsfinish
def randommin=2
def randommax=6
def spanks
def percent
def says=["I am a failure.","I have no self control.","I deserve punishment.",
	"Spank me harder.","I’m a naughty "+(female ? "girl." : "boy.")]
def saysnum=[]
def nsays=5
def unstrip=""
def unstriptext=""
def cornerlist=[]  // EERCCC - EE =Enhanced numb, R=RL Flag, CCC=Corner numb
def cornermin=0
def cornermax=0
def cornerplus=0
def ncornerlist=0
def kcornerswap
def repeat=-1
def nude=false
def underware=false
def optall=true
def optplus
def optenh
def optrep
def optrep2

def setmin
def setmax
def setspanks
def setpercent
def leastmin
def leastadd
def leastspanks
def leastpercent

def settings={mydom ->
	setmin=2
	setmax=6
	setspanks=25
	setpercent=10
	leastmin=mydom ? 2 : 1
	leastadd=mydom ? 2 : 1
	leastspanks=mydom ? 5 : 1
	leastpercent=0
}

def domimagefile
def whyhere=""
def readme=0

///////////////////////////////////////////////////////////////////////////////

def getstay =
{
	yourstay++
	return (getstayfile(stay[yourstay%nstay]))
}

def getlap =
{
	yourlap++
	return (getlapfile(lap[yourlap%nlap]))
}

def gethost2 =
{
	if (optdom)
		return getlap()
	else
		return getstay()
}

def exitting=
{
	if (optdom)
		return ("TheSnowyOwl/exit"+(pointsfinish%4)+".jpg")
	else
		return gethost2()
}

///////////////////////////////////////////////////////////////////////////////

def target=4
def targetwl=6

def streakwon=
{
	def streak=loadIntegerVal(properties+"streak", 0)+1
	save(properties+"streak", streak)
	def streakwl=loadIntegerVal(properties+"streakwl", 0)+1
	if (streakwl > targetwl)
		streakwl=targetwl
	save(properties+"streakwl", streakwl)
}

def streaknot=
{
	save(properties+"streak", null)
	def streakwl=loadIntegerVal(properties+"streakwl", 0)-1
	if (streakwl > 0)
		save(properties+"streakwl", streakwl)
	else
	{
		save(properties+"streakwl", null)
		save(properties+"streakreset", null)
	}
}

def streaklost=
{
	if (optdom)
	{
		def quitter=loadIntegerVal(properties+"quitter",0)
		save(properties+"quitter",quitter+1)
	}
	streaknot()
}

def streakcheck = {
	def streak=loadIntegerVal(properties+"streak",0)
	def streakwl=loadIntegerVal(properties+"streakwl",0)
	if (streak >= target | streakwl >= targetwl)
	{
		setImage(getlap())
		def msg=""
		if (!optdom)
		{
			def whine=["It's not fair!  I never get to spank you.",
				"I want to spank you.",
				"Why am I here if I do not get to spank you?",
				"How long has it been since you were last spanked?"]
			msg=whine[getRandom(4)]+" "
		}
		if (loadIntegerVal(properties+"streakreset",0) > 0)
			msg+="Since the time was last increased, you "
		else
			msg+="You "
		if (streak >= target)
			msg+="have won "+streak+" games in a row."
		else
			msg+="have generally been winning more games than you are losing."
		msg+="\n\nThe time should be increased. "
		msg+="Minimum should be increased from "+randommin+" minutes to "+(randommin+1)+" minutes. "
		msg+="Maximum should be increased from "+randommax+" minutes to "+(randommax+1)+" minutes. "
		def button=getSelectedValue(msg, ["OK", "No - keep as is"])
		if (button == 1 & optdom)
			button=getSelectedValue("This is not a choice. Values will be increased anyway!" , ["OK"])
		if (button == 0)
		{
			randommin++
			save(properties+"random.min", randommin)
			randommax++
			save(properties+"random.max", randommax)
			save(properties+"streak", null)
			save(properties+"streakwl", null)
			save(properties+"streakreset", 1)
		}
		setImage(imagefile)
	}
}

///////////////////////////////////////////////////////////////////////////////

def failed=", you have failed. "
def cntenh=[]
def cntenhout=0
def enhavail=[0]
def object=""
def $wr1
def $wr2
def $wr3
def $pen
def $icb
def $ict
def $cpt
def $ice
def $cpb
def $cp3
def $cp
def $too
def $soa
def $rub
def $bag
def $dog
def $n=99

def $write= {  count ->
	def phrases=["Please spank me.", "I deserve punishment.",
		"I will not lie ever again.",
		"I will not forget my password.", "I will admit my mistakes.",
		"I am sorry.  I apologize.",
		"All of these positions are easy.","I can do any position.","I will stay in position."]
	def times=[0,15,7,5]
	def msg=""
	if (count > 1)
		msg+="get "+count+" sheets of paper.  On each sheet, write "
	else
		msg+="get a sheet of paper.  Write "
	msg+=times[count]+" times (number them) this phrase:\n &nbsp; "
	msg+=phrases[getRandom(9)]
	msg+="\nWrite clearly and spell all words correctly. "
	return msg
}

def enhkeys=["write","pencil","ice","clothespins","toothbrush","soap",
	"rubberbands","paperbag","dogcollar"]
def enhnames=["write lines","kneel on pencils","ice against body",
	"clothespins on body","toothbrush in mouth","soap in mouth",
	"snap rubberbands on wrists","paperbag over head","dog collar (belt) on neck"]
def nenhkeys=9

def enhanceinfo= {passenh, why ->	// why: 0=text, 1=set variables
	def enh=passenh
	def msg="First, "
	def sep="\n\n"
	underware=false
	def myobj=""
	def id="x"
	switch(enh)
	{
	default:
		msg=""
		sep=""
		break
	case 11:
		if (loadIntegerVal(properties+"enh.write",1)==0)
			enh=0
		$wr1=enh
		id="wr1"
		msg+=$write(1)
		break
	case 12:
		if (loadIntegerVal(properties+"enh.write",1)==0)
			enh=0
		$wr2=enh
		id="wr2"
		msg+=$write(2)
		break
	case 13:
		if (loadIntegerVal(properties+"enh.write",1)==0)
			enh=0
		$wr3=enh
		id="wr3"
		msg+=$write(3)
		break
	case 14:
		if (loadIntegerVal(properties+"enh.pencil",1)==0)
			enh=0
		$pen=enh
		id="pen"
		msg+="place several pencils on the floor where you are going to kneel. "
		break
	case 15:
		if (loadIntegerVal(properties+"enh.ice",1)==0)
			enh=0
		$ict=enh
		id="ict"
		msg+="place 2 ice cubes under your chin and "
		msg+="bend your head down to hold them. "
		msg+="If the ice cubes fall"+failed
		myobj="ice cubes"
		break
	case 16:
		if (loadIntegerVal(properties+"enh.ice",1)==0)
			enh=0
		$icb=enh
		id="icb"
		if (why == 0)
		{
			if (nude)
			{
				msg+="put on your "+clothes[3]+". Then, "
				underware=true
			}
			msg+="place 2 ice cubes between the wasteband of your "+clothes[3]
			msg+=" and your body.  If the ice cubes fall"+failed
		}
		myobj="ice cubes"
		break
	case 26:
		$n=enh	// highest number
		if (loadIntegerVal(properties+"enh.ice",1)==0)
			enh=0
		$ice=enh
		id="ice"
		break
	case 17:
		if (loadIntegerVal(properties+"enh.clothespins",1)==0)
			enh=0
		$cpt=enh
		id="cpt"
		if (!nude)
			msg+="remove all clothes above the waist.  Then, "
		unstrip="your clothes above the waist"
		msg+="place two clothespins - one on each breast."
		myobj="clothespins"
		break
	case 18:
		if (loadIntegerVal(properties+"enh.clothespins",1)==0)
			enh=0
		$cpb=enh
		id="cpb"
		if (!nude)
			msg+="remove all clothes below the waist.  Then, "
		unstrip="your clothes below the waist"
		msg+="place a clothespin on your "+(female ? "pussy." : "penis.")
		myobj="clothespin"
		break
	case 19:
		if (loadIntegerVal(properties+"enh.clothespins",1)==0)
			enh=0
		$cp3=enh
		id="cp3"
		if (!nude)
		{
			msg+="remove all clothes above and below the waist. "
			msg+="(You may keep your socks & shoes.) Then, "
		}
		unstrip="your clothes above & below the waist"
		msg+="place two clothespins - one on each breast. "
		msg+="Place a third clothespin on your "+(female ? "pussy." : "penis.")
		myobj="clothespins"
		break
	case 20:
		if (loadIntegerVal(properties+"enh.clothespins",1)==0)
			enh=0
		$cp=enh
		id="cp"
		break
	case 21:
		if (loadIntegerVal(properties+"enh.toothbrush",1)==0)
			enh=0
		$too=enh
		id="too"
		msg+="place a toothbrush in your mouth (no tooth paste). "
		msg+="After you click begin, if you touch the toothbrush or "
		msg+="it comes out of your mouth"+failed
		myobj="toothbrush"
		break
	case 22:
		if (loadIntegerVal(properties+"enh.soap",1)==0)
			enh=0
		$soa=enh
		id="soa"
		msg+="place a bar of soap in your mouth."
		myobj="bar of soap"
		break
	case 23:
		if (loadIntegerVal(properties+"enh.rubberbands",1)==0)
			enh=0
		$rub=enh
		id="rub"
		msg+="place 2 rubber bands, one on each wrist.\n\n"
		msg+="After clicking begin and before the alarm sounds, "
		msg+="pull the rubber band back as far as possible and let go "
		msg+="a total of "+(randommin+randommax)+" times.  Alternate wrists. "
		msg+="If you do not complete this"+failed
		myobj="rubber bands"
		break
	case 24:
		if (loadIntegerVal(properties+"enh.paperbag",1)==0)
			enh=0
		$bag=enh
		id="bag"
		msg+="get a paper bag.\n\n"
		msg+="Place the paper bag over your head as part of getting in position."
		myobj="paper bag"
		break
	case 25:
		if (loadIntegerVal(properties+"enh.dogcollar",1)==0)
			enh=0
		$dog=enh
		id="dog"
		msg+="put a dog collar around your neck. "
		msg+="If you do not have a dog collar, use a belt. DO&nbsp;NOT&nbsp;TIGHTEN!"
		myobj="dog collar or belt"
		break
	// case 26 above
	}
	if (enh > 0)
		enhavail[enh]=id
	if (why == 0)
		return (msg+sep)
	else
		return myobj
}

def enhancetext= {tries ->
	if (!optenh)
		return ""
	def enh=(int)(cornerlist[tries%ncornerlist]/10000)
	return enhanceinfo(enh,0)
}

def ee= {tries, pick->
	if (tries < 0)
	{
		cntenhout++
		for(def ipick=0 ; pick[ipick] != null ; ipick++)
		{
			if (cntenh[pick[ipick]] == null)
				cntenh[pick[ipick]]=0
			cntenh[pick[ipick]]++
		}
		return 90
	}
	if (!optenh)
		return 0
	def enh=(int)(cornerlist[tries%ncornerlist]/10000)
	if (enh <= $n & enhavail[enh] == null)
	{
		enh=0
		cornerlist[tries%ncornerlist]=cornerlist[tries%ncornerlist]%10000
	}
	if (enh == 0)
	{
		def mylast=[0,0,0,0]
		for (def j=1 ; j<=3 ; j++)
		{
			if (debugtext)
			{
				if ((tries-j)>=0)
					mylast[j]=(int)(cornerlist[(tries-j)%ncornerlist]/10000)
			}
			else
				mylast[j]=(int)(loadIntegerVal(properties+"lastcorner"+j, 0)/10000)
		}
		def cp=[$cpt,$cpb,$cp3]
		def ice=[$ict,$icb]
		def sqz=[]
		def next=99
		def nsqz=0
		for (def ipick=0 ; next != null ; ipick++)
		{
			def keep=true
			if (next == 0)
				keep=false
			if (next == $cp)
				next=cp[getRandom(3)]
			if (next == $ice)
				next=ice[getRandom(2)]
			for(def i=1 ; i<=3 ; i++)
			{
				if (next == mylast[i])
					keep=false
			}
			if (keep)
			{
				sqz[nsqz]=next
				nsqz++
			}
			next=pick[ipick]
		}
		if (nsqz == 0)
			enh=99
		else
			enh=sqz[getRandom(nsqz)]
		cornerlist[tries%ncornerlist]+=enh*10000
	}
	object=enhanceinfo(enh,1)
	return enh	
}

///////////////////////////////////////////////////////////////////////////////

def cornerinfo = { intries, why ->	// why: 0=text, 1=group, 2=image, -1=cntenh
	def corner=cornerlist[intries%ncornerlist]%1000
	def randrl=0==((int)(cornerlist[intries%ncornerlist]/1000)%10)
	def squmsg=""
	def group=corner
	def squimage=0
	def star=" "
	def enh=0
	unstrip=""
 	def tries=intries
	if (why < 0)
	{
		tries=-1
		randrl=false
	}
	switch(corner)
	{
	// match SlideLadderDare - 35 & 46 & 49 & 50 modified
	// no hand position specified - (39), 45, (46), 53, 54, 55, 56, 62, 64, 65
	case 35:
		for (def i=0 ; i<3 ; i++)
		{
			if (cornerlist[i]%1000 == 65)
				randrl=true
		}
		if (randrl)
			squmsg+="Sit in the middle of a non-carpeted floor. "
		else
			squmsg+="Sit on a chair with  wooden seat (preferred) or hard seat. "
		squmsg+="Spread your legs apart as far as possible.  "
		squmsg+="Place both hands on your knees.  "
		break

	case 39:  // v2.0 - moved from 52
		squimage=52
		if (why <= 0)
			enh=ee(tries,[$ice,$cp,$too,$soa,$bag])  // ,$dog
		squmsg+="Stand facing the corner with your hands at your side and do not move. "
		squmsg+="Absolutely no motion. "
		break
	case 40:
		squimage=likemale ? 140 : 40  // v2.0 - condition added
			// v2.0 - image 40 moved to 40m; 40 is new image
		if (why <= 0)
			enh=ee(tries,[$ice,$cp,$too,$soa,$rub,$bag])  // ,$dog
		squmsg+="Stand in the middle of the room with your hands straight up in the air.  "
		squmsg+="No touching anything.  "
		break
	case 41:
		squimage=41
		if (why <= 0)
			enh=ee(tries,[$cp,$too,$soa,$bag,$dog])
		squmsg+="Stand in the middle of the room with your feet apart.  "
		squmsg+="Now bend forward and place your palms flat on the floor. "
		squmsg+="(You may bend your knees a little.)  "
		break
	case 42:
		squimage=42
		if (why <= 0)
			enh=ee(tries,[$cp,$icb,$pen,$dog])
		squmsg+="Kneel "+((enh==$pen) ? "on the pencils" : "")
		squmsg+=" in the middle of "+((optdom|optenh) ? "a non-carpeted" : "the")
		squmsg+=" floor with your knees spread wide.  "
		squmsg+="Lean forward and place your head upon the floor then reach out with "
		squmsg+="your arms fully extended, palms against the floor.  "
		squmsg+="Fanny should be high in the air. "
		break
	case 43:
		if (why <= 0)
			enh=ee(tries,[$pen,$ice,$too,$soa,$bag])  // ,$cp,$dog
		squmsg+="Kneel "+((enh==$pen) ? "on the pencils" : "")
		squmsg+=" in the middle of the room "
		squmsg+=((optdom|optenh) ? "on a non-carpeted floor " : " ")
		squmsg+="in an upright position with both hands out stretched to the side, "
		squmsg+="palms up.  "
		break
	// 44 & 45 are new
	case 46:	// SlideLadderDare said Stand
		star="*"
		squimage=randrl ? 46 : (likemale ? 57 : 50)  // v2.0 - male condition added
				// v2.0 - 46 replaced with pic446; old 46 is now 93; old 93 is now 23m
				// v2.0 - 50 replaced with pic450; old 50 is now 97; old 97 is now 24m;
		if (why <= 0)
		{
			if (randrl)
				enh=ee(tries,[$icb,$dog])
			else
				enh=ee(tries,[$pen,$icb,$dog])
		}
		squmsg+=randrl ? "Stand" : ((optdom|optenh) ? 
			("Kneel "+((enh==$pen) ? "on the pencils" : "")+" on a non-carpeted floor") : "Kneel")
		squmsg+=" facing the wall with your hands at your side.  "
		squmsg+="Hold a coin against the wall with your nose.  "
		squmsg+="Do not touch the wall (except nose & coin). "
		if (object.length() > 1)
			squmsg+="The "+object+" must not touch the wall. "
		squmsg+="If the coin falls or you touch the wall"+failed
		break
	case 47:
		squimage=47
		if (why <= 0)
			enh=ee(tries,[$ice,$cpt,$dog])
		squmsg+="Stand facing the corner with your "
		squmsg+=randrl ? "left" : "right"
		squmsg+=" thumb in your mouth and "
		randrl=(!randrl) ? "left" : "right"
		if (female)
			squmsg+="the fingers of your "+randrl+" hand in your vagina."
		else
			squmsg+="your "+randrl+" hand on your penis."
		break
	case 48:
		squimage=48
		if (why <= 0)
			enh=ee(tries,[$ict,$too,$soa,$dog])
		unstrip="your "+clothes[2]+" and "+clothes[3]
		if (nude)
			squmsg+="Locate your "+clothes[3]+". "
		else
			squmsg+="Remove "+clothes[2]+" and "+clothes[3]+". "
		squmsg+="Stand facing the corner with your "
		squmsg+=clothes[3]+" on your head and both hands on your bare fanny. "
		break
	case 49:	// SlideLadderDare said Book
		squimage=likemale ? 149 : 0  // v2.0 - 49m is new image
		if (why <= 0)
			enh=ee(tries,[$wr1,$cp,$icb,$too,$soa])  // ,$dog
		randrl=(enh==$wr1) ? "this sheet of paper" : (randrl ? "a book" : "a pen or pencil")
		squmsg+="Stand facing the corner with both hands on your fanny and "
		squmsg+=randrl+" on your head. "+"If it falls off"+failed
		break
	case 50:	// SlideLadderDare said Kneel
		star="*"
		group=46
		if (why <= 0)
		{
			if (randrl)
				enh=ee(tries,[$cp,$icb,$dog])
			else
				enh=ee(tries,[$cp,$pen,$icb,$dog])
		}
		squimage=randrl ? 46 : (likemale ? 57 : 50)  // v2.0 - see case46
		squmsg+=randrl ? "Stand" : ((optdom|optenh) ? 
			("Kneel "+((enh==$pen) ? "on the pencils" : "")+" on a non-carpeted floor") : "Kneel")
		squmsg+=" facing the wall with your hands on your head.  Hold a coin against the wall "
		squmsg+="with your nose.  If the coin falls"+failed
		break
	case 51:
		if (why <= 0)
			enh=ee(tries,[$ice,$cp,$too,$soa,$bag,$dog])  // 6
		squmsg+="Stand in a doorway with your legs spread and touching the corners of the "
		squmsg+="door frame.  Raise your right hand and touch the upper right corner of the frame.  "
		squmsg+="Raise your left hand and touch the upper left corner of the frame.  "
		break

	// New Positions
	case 44:
		group=43
		if (why <= 0)
			enh=ee(tries,[$ice,$cp,$too,$soa,$bag,$dog])  // 6
		squmsg+="Stand in the middle of the room with your hands straight out "
		squmsg+="in front of you, palms up.  Place "
		if (randrl)
			squmsg+="a book on your palms. If the book falls"+failed
		else
		{
			squmsg+="the "+(imprandom ? imp[tries%nimp] : impdefault)
			squmsg+=" on your palms and think about your spanking if it falls. "
		}
		break
	case 45:
		if (why <= 0)
			enh=ee(tries,[$wr1,$ict,$cpt,$too,$soa,$rub,$bag])  // ,$dog
		squmsg+="Stand facing the corner with "
		squmsg+=((enh == $wr1) ? "this sheet of paper" : "a book")+" between your knees. "
		squmsg+="If the "+((enh == $wr1) ? "sheet of paper" : "book")
		squmsg+=" falls"+failed
		squmsg+="If you touch the "+((enh == $wr1) ? "sheet of paper" : "book")
		squmsg+=" with anything other than your knees"+failed
		break
	case 52:  // v2.0 - new; old 52 moved to 39
		group=61
		squimage=59  // Image 52 used by 39
		if (why <= 0)
			enh=ee(tries,[$ice,$cp,$too,$soa,$bag,$dog])  // 6
		squmsg+="Stand facing the wall. "
		squmsg+="Place 2 coins, one under each index finger against the wall. "
		squmsg+="Move as far from the wall as possible. Other than the index fingers, "
		squmsg+="no part of your body including other fingers can touch the wall. "
		if (object.length() > 1)
			squmsg+="The "+object+" must not touch the wall. "
		squmsg+="If a coin falls"+failed
		break
	case 53:
		group=46
		squimage=53
		if (why <= 0)
			enh=ee(tries,[$icb,$dog])
		squmsg+="Stand facing the wall.  Use your head to hold the "
		squmsg+=(imprandom ? imp[tries%nimp] : impdefault)+" against the wall. "
		squmsg+="If it falls or you touch it with anything other than your head"+failed
		squmsg+="No part of your body, except your head, is allowed to touch the wall. "
		if (object.length() > 1)
			squmsg+="The "+object+" must not touch the wall. "
		break
	case 54:
		group=43
		squimage=54
		if (why <= 0)
			enh=ee(tries,[$ice,$too,$soa,$rub,$bag])  // ,$dog
		unstrip="your shoes"
		if (nude)
			squmsg+="You should already be barefoot. "
		else
			squmsg+="Remove your shoes. "
		squmsg+="Stand in the middle of the room with your heels off the ground. "
		squmsg+="No touching anything. "
		break
	case 55:
		if (why <= 0)
			enh=ee(tries,[$ice,$too,$soa,$rub,$bag])  // ,$dog
		unstrip="your shoes"
		if (nude)
			squmsg+="You should already be barefoot. "
		else
			squmsg+="Remove your shoes. "
		squmsg+="Stand facing the corner with a pen or pencil in an upright position between "
		squmsg+="your two feet. "
		squmsg+="No other part of your body may touch the pen or pencil. "
		squmsg+="If the pen or pencil tips"+failed
		break
	case 56:
		group=55
		if (why <= 0)
			enh=ee(tries,[$ice,$too,$soa,$rub,$bag])  // ,$dog
		unstrip="your socks & shoes"
		if (nude)
			squmsg+="You should already be barefoot. "
		else
			squmsg+="Remove every thing covering your feet (shoes, socks). "
		squmsg+="Stand facing the corner with 2 pens or pencils in an upright position -- "
		squmsg+="one between the toes of one foot and the "
		squmsg+="other between the toes of the other foot. "
		squmsg+="No other part of your body may touch the pens or pencils. "
		squmsg+="If either of the pens or pencils tips"+failed
		break
	case 57:
		group=46
		squimage=likemale ? 57 : 50  // v2.0 - condition added
		if (why <= 0)
			enh=ee(tries,[$icb,$pen,$dog])
		squmsg+=((optdom|optenh) ? ("Kneel "+((enh==$pen) ? "on the pencils" : "")+" on a non-carpeted floor") : "Kneel")
		squmsg+=" facing the wall.  Touch the floor with your "
		squmsg+=randrl ? "left" : "right"
		squmsg+=" hand. At the same time, hold a coin against the wall "
		squmsg+="with your nose. "
		squmsg+="No part of your body, other than your nose, may touch the coin. "
		squmsg+="If the coin falls"+failed
		break
	case 58:	// v2.0 - new; old 58 moved to 101
		squimage=58  // v2.0 - new image; old 58 image moved to 62
		if (why <= 0)
			enh=ee(tries,[$too,$soa,$bag,$dog])
		squmsg+="Stand in the middle of the room. "
		squmsg+="Bend and place both hands on your knees. "
		squmsg+="Place the "+(imprandom ? imp[tries%nimp] : impdefault)
		squmsg+=" on your back.  It it falls off"+failed
		break
	case 59:
		squimage=59
		if (why <= 0)
			enh=ee(tries,[$ict,$too,$soa,$bag,$dog])
		squmsg+="Place a chair against the wall with the back of the chair "
		squmsg+="farthest from the wall. "
		squmsg+="Lean over the chair and place both hands on the wall. "
		break
	case 60:
		squimage=59
		if (why <= 0)
			enh=ee(tries,[$ice,$cp,$too,$soa,$bag,$dog])  // 6
		squmsg+="Stand facing the wall.  Hold 5 coins against the wall -- "
		squmsg+="one for each finger of your "
		squmsg+=randrl ? "left" : "right"
		squmsg+=" hand.  If your "
		squmsg+=(!randrl) ? "left" : "right"
		squmsg+=" hand or any other part of your body touches any coin "
		squmsg+="or any coin falls"+failed
		break
	case 61:
		squimage=59
		if (why <= 0)
			enh=ee(tries,[$wr2,$wr2,$ice,$cp,$too,$soa])  // ,$bag,$dog
		squmsg+="Face the wall. "
		squmsg+="Hold "+((enh == $wr2) ? "these" : "")
		squmsg+=" 2 sheets of paper against the wall -- one with each hand. "
		squmsg+="Move back from the wall so that your elbows are not bent. "
		squmsg+="If either of the 2 sheets of paper fall"+failed
		break
	case 62:
		group=61
		squimage=62    // v2.0 - old 58 image moved to 62
		if (why <= 0)
			enh=ee(tries,[$wr3,$wr3,$icb,$rub])  // ,$dog
		unstrip="the clothes above the waist"
		if (nude)
			squmsg+="You should have already removed "
		else
			squmsg+="Remove "
		squmsg+="all clothes above the waist. Face the wall. "
		squmsg+="Hold "+((enh == $wr3) ? "2 of these" : "2")
		squmsg+=" sheets of paper against the wall -- one with each boob. "
		squmsg+="Hold a third sheet of paper with your nose. "
		squmsg+="If you touch any of the sheets of paper with your hand "
		squmsg+="or any other part of your body"+failed
		squmsg+="If any of the 3 sheets of paper fall"+failed
		break
	case 63:
		if (why <= 0)
			enh=ee(tries,[$cp,$icb,$too,$soa,$bag,$dog])  // 6
		squmsg+="Sit on the floor in the middle of the room. "
		squmsg+="Place your hands on the floor behind you. "
		squmsg+="Raise your fanny off of the ground. "
		break
	case 64:
		squimage=64
		if (why <= 0)
			enh=ee(tries,[$ict,$too,$soa,$rub,$bag,$dog])  // 6
		unstrip="the clothes below the waist"
		if (nude)
			squmsg+="You should have already removed "
		else
			squmsg+="Remove "
		squmsg+="all clothes below the waist. "
		squmsg+="Face the corner while holding the wooden spoon "
		squmsg+="between the cheeks of your fanny and parallel to your body. "
		squmsg+="No other part of your body may touch the wooden spoon. "
		squmsg+="If it falls"+failed
		if (!loadBooleanVal("toys.wooden_spoon", false))
			squmsg+=" (If you do not have a wooden spoon, substitute another spanking implement.) "
		break
	case 65:	// v2.1 - new
		if (why <= 0)
			enh=ee(tries,[$ict,$cp,$too,$soa,$bag,$dog])  // 6
		squmsg+="Sit in a chair.  Raise both legs off of the floor. "
		squmsg+="Your legs may not touch or lean on anything. "
		break
	case 66:	// v2.1 - new
		if (why <= 0)
			enh=ee(tries,[$pen,$icb,$cp,$dog])
		squmsg+=((optdom|optenh) ? ("Kneel "+((enh==$pen) ? "on the pencils" : "")+" on a non-carpeted floor") : "Kneel")
		squmsg+=" facing the wall.  Back up a bit from the wall. "
		squmsg+="Put your hands behind your head and rest your elbows on the wall. "
		squmsg+="Lift your feet off the floor.  If your feet touch the floor, you have failed. "
		break
	case 67:	// v2.1 - new
		squimage=67
		if (why <= 0)
			enh=ee(tries,[$ice,$too,$soa,$dog])
		squmsg+="Lie on the floor on your back. "
		squmsg+="Raise your legs and put your arms around the back of your knees "
		squmsg+="and clasp your hands. "
		break
	case 68:	// v2.1 - new
		group=67
		if (why <= 0)
			enh=ee(tries,[$ice,$too,$soa,$rub,$dog])
		squmsg+="Lie on the floor on your back. "
		squmsg+="Raise your legs into the air so that your fanny is off the floor. "
		break

//		if (why <= 0)
//			enh=ee(tries,[$wr1,$pen,$ice,  $cp,$too,$soa,$rub,$bag,$dog])

	case 101:	// v2.0 - moved from 58
		squimage=62      // v2.0 - old 58 image moved to 62
		if (why <= 0)
			enh=ee(tries,[$rub,$bag,$dog])
		squmsg+="Stand facing the wall with "
		squmsg+="the toes of both feet and both knees touching the wall. "
		break
	case 102:	// v2.0 - new
		if (why <= 0)
			enh=ee(tries,[$ict,$cpt,$too,$soa,$rub,$bag])  // ,$dog
		squmsg+="Stand with your back against the wall. "
		squmsg+="Slide down until the legs above the knees are parallel to the floor. "
		break
	}
	if (why < 0)
		return 0
	else if (why == 1)
		return group
	else if (why == 2)
		return squimage
	else if (debugtext)
		return ("Case "+corner+", Image "+squimage+star+"\n"+squmsg)
	else
		return squmsg
}

cornermin=optdom ? 40 : 39
cornermax=68
cornerplus=102

def cornertext = {tries ->
	def text=cornerinfo(tries,0)
	text=enhancetext(tries)+text
	unstriptext=unstrip
	def corner=cornerlist[tries%ncornerlist]%1000
	if (!debugtext & corner != 35)
	{
		save(properties+"lastcorner1", loadIntegerVal(properties+"lastcorner2",0))
		save(properties+"lastcorner2", loadIntegerVal(properties+"lastcorner3",0))
		save(properties+"lastcorner3", cornerlist[tries%ncornerlist])
		if (tries == 0)
		{
			def sld=loadIntegerVal("TheSnowyOwl.SlideLadderDare.launch.lasttime",0)
			if (sld > 0)
				save(properties+"last.SLD", sld)
		}
	}
	if (!debugtext & optrep & tries < 3)
	{
		def repeatcorner=0
		def squeeze=false
		for (repeat=-1 ; repeatcorner != null ; )
		{
			repeat++
			repeatcorner=loadInteger(properties+"repeat"+repeat)
			if (repeatcorner != null)
			{
				if (squeeze)
					save(properties+"repeat"+(repeat-1),repeatcorner)
				if (repeatcorner%1000 == corner)
					squeeze=true
			}
		}
		if (squeeze)
			repeat--
		save(properties+"repeat"+repeat,cornerlist[tries%ncornerlist])
		save(properties+"repeat"+(repeat+1),null)
	}
	else
		repeat=-1
	return text
}

def startcorner={
	cornerlist=newdeck(cornermin, cornermax)
	ncornerlist=cornermax-cornermin+1
	if (optplus)
	{
		cornerlist=joindeck(cornerlist, ncornerlist, newdeck(101, cornerplus), cornerplus-100)
		ncornerlist+=(cornerplus-100)
	}
	if (debugtext)
	{
		cornerlist=joindeck(cornerlist, ncornerlist, [1046,1050], 2)
		ncornerlist+=2
	}
	cornerlist[ncornerlist]=cornerlist[3]
	cornerlist[3]=980035
	ncornerlist+=1
	if (!debugtext)
	{
		for(def icorner=0 ; icorner<ncornerlist ; icorner++)
			cornerlist[icorner]+=1000*getRandom(2)
	}
	if (optrep & !debugtext)
	{
		def repeat0=loadIntegerVal(properties+"repeat0", 0)
		if (optrep2)
			repeat0=repeat0%10000
		if (repeat0 > 0)
		{
			cornerlist[ncornerlist]=cornerlist[0]
			cornerlist[0]=repeat0
			ncornerlist+=1
		}
	}
	def mylast1=loadIntegerVal(properties+"lastcorner1", 0)%1000
	def mylast2=loadIntegerVal(properties+"lastcorner2", 0)%1000
	def mylast3=loadIntegerVal(properties+"lastcorner3", 0)%1000
	def sldlast=0
	if (loadIntegerVal("TheSnowyOwl.SlideLadderDare.launch.lasttime",0) >
		loadIntegerVal(properties+"last.SLD", 0))
		sldlast=loadIntegerVal("TheSnowyOwl.SlideLadderDare.lastcorner", 0)
	if (sldlast == 52)  // v2.0 - 52 moved to 39
		sldlast=39
	def swapto=ncornerlist-1
	for (def i=0 ; i<=2 ; )
	{
		def swap=false
		def ccc=cornerlist[i]%1000
		if (ccc == mylast1 | ccc == mylast2 | ccc == mylast3 | ccc == sldlast)
			swap=true
		def myimage=cornerinfo(i,2)
		if (i > 0 & !swap)
		{
			if (cornerinfo(i,1) == cornerinfo(0,1))
				swap=true
			if (myimage != 0 & myimage == cornerinfo(0,2))
				swap=true
		}
		if (i > 1 & !swap)
		{
			if (cornerinfo(i,1) == cornerinfo(1,1))
				swap=true
			if (myimage != 0 & myimage == cornerinfo(1,2))
				swap=true
		}
		if (swap)
		{
			def tmp=cornerlist[i]
			cornerlist[i]=cornerlist[swapto]
			cornerlist[swapto]=tmp
			swapto--
		}
		else
			i++
	}
	kcornerswap=(ncornerlist-1)-swapto
}

///////////////////////////////////////////////////////////////////////////////

def inminutes={ sec ->
	def msg=""
	def seconds=(int)(sec+0.9)
	def minutes=(int)(seconds/60)
	seconds=seconds-60*minutes
	if (minutes > 0)
	{
		if (seconds == 0)
			msg+="exactly "
		msg+=unit(minutes,"Minute","Minutes")
	}
	else if (seconds == 0)
		seconds=1
	if (seconds != 0)
		msg+=" "+unit(seconds,"Second","Seconds")
	return msg
}

def failure=["There is a penalty for failure.", "Failure must be punished.",
	"Time for your punishment.", "Failure implies a spanking."]
def nfailure=4
def keepoff=["Leave your clothes off.","Do not even think of getting dressed.",
	"Remain naked.","Remain naked goes without saying."]
def nkeepoff=4

def thecorner={tries ->
	def msg=cornertext(tries)
	def myimage=cornerinfo(tries,2)
	if (myimage == 0)
	{
		def i=(int)(cornerlist[tries%ncornerlist]/10000)
		if ($soa == i)
			setImage(getstayfile(10))
		else if ($bag == i)
			setImage(getstayfile(11))
		else
			setImage(getstay())
	}
	else
		setImage(getstayfile(myimage))
	def msg1=" Remain in this position until the alarm rings."
	def extra=0
	if (cornerlist[tries%ncornerlist]%1000 == 60)
	{
		extra=4
		msg1+="\n\nSince this will take extra time to get in position, "
		msg1+="a few seconds have been added to the time. "
	}
	if (debugtext & unstriptext.length() > 1)
		msg1+="\n\nEnd Msg: "+unstriptext
	show(msg+msg1)
	showButton("I am ready to begin.")
	if (debugtext)
	{
		if (tries < ncornerlist)
			return 0
		else
			return 2
	}
	def did=2
	wait(did)
	if (extra > 0)
		wait(extra)
	def rand=getRandom(60*randommax-60*randommin+1)+(60*randommin)
	rand=(int)(rand*(1+tries*percent/100)+0.5)
	def rand1=rand
	if (rand1 > did)
		rand1=rand1-did
	if (debugmode)
		rand1=5
	did=showButton("Click if you fail before time expires", rand1)
	def msg2="\n\nTime was set to "+inminutes(rand)+"."
	def didnt=rand1-did
	if (didnt <= 1)
		ringalarm()
	if (object.length() > 1)
		showPopup("Remove the "+object+".")
	object=""
	if (didnt > 1)
	{
		def msg3=" You had "+inminutes(didnt)+" to go."
		show(msg+msg2+msg3)
		showButton("Continue to the Penalty")
	}
	else
	{
		def button=getSelectedValue(msg+msg2, ["Failed", "Succeeded"])
		if (button == 1)
			return 2
	}
	def mustsay=null
	if (tries == 0)
		failure=shuffle(failure, nfailure)
	msg=failure[tries%nfailure]+" "
	if (!nude)
	{
		if (getRandom(2) == 0 | unstriptext.length()>1)
			msg+="Proper spankings are done in the nude. "
		else
			msg+="Those clothes give you too much protection for a spanking. "
		msg+="Remove all of your "+((unstriptext.length()>1) ? "remaining" : " ")+" clothes."
		show(msg)
		showButton("I have removed everything")
		msg=""
		nude=true
	}
	else
	{
		if (underware)
		{
			show(msg+" Remove your "+clothes[3]+".")
			showButton("Done")
			msg=""
			underware=false
		}
	}
	if (tries > 0 | optdom)
	{
		msg+="You are to count the spanks out loud.  After the number you must say, out loud:\n"
		def ksays=saysnum[tries%nsays]
		mustsay=says[ksays]
		if (tries == 0 & optdom)
			mustsay=whyhere
		else
			save(properties+"lastsays", ksays)
		show(msg+mustsay)
		showButton("I understand")
	}
	setImage(getlap())
	def ilap=lap[yourlap%nlap]
	save(properties+"lastlap",ilap)
	def spanks1=(int)(spanks*(1+tries*percent/100)+0.5)
	if (debugmode)
		spanks1=3
	def myimplement
	if (imprandom)
	{
		if (cornerlist[tries%ncornerlist]%1000 == 64)
			myimplement="wooden spoon"
		else
			myimplement=imp[tries%nimp]
	}
	else
		myimplement=impdefault
	spankme(spanks1, myimplement, mustsay)
	setImage(gethost2())
	if (tries == 0)
		keepoff=shuffle(keepoff,nkeepoff)
	msg=keepoff[tries%nkeepoff]+" "
	msg+="Are you ready to try again with a different position? "
	if (tries == 2)
		msg+="Maybe the next position will be an easy one. "
	if (percent > 0)
	{
		msg+="\n\nThe time will be increased by "
		msg+=(percent*(tries+1))+" percent and if you fail, "
		msg+="the number of spanks will also be increased by "+(percent*(tries+1))+" percent."
	}
	def tryorquit
	for (def running=true ; running ; )
	{
		tryorquit=getSelectedValue(msg, ["I will try again", "I quit"])
		if (optdom & tryorquit == 1)
			showPopup("Quitting is not allowed!")
		else
			running=false
	}
	return tryorquit
}

///////////////////////////////////////////////////////////////////////////////
// Standard / Dom

def std2dom=
{
	def fini=loadIntegerVal(properties+"finish.1", 0)+loadIntegerVal(properties+"finish.2", 0)+
		loadIntegerVal(properties+"finish.3", 0)
	def msg=""
	msg+="The Dom Edition was written by The Red Owl, the evil twin of The Snowy Owl. "
	msg+="Activate&nbsp;at&nbsp;your&nbsp;own&nbsp;risk!"
	def msg1=""
	settings(true)
	if (randommin < leastmin)
		msg1+="Minimum time will be reset from "+randommin+" to "+leastmin+". "
	def x=((randommin > leastmin) ? randommin : leastmin)+leastadd
	if (randommax < x)
		msg1+="Maximum time will be reset from "+randommax+" to "+x+". "
	if (spanks < leastspanks)
		msg1+="Number of spanks for first failure will be reset from "+spanks+" to "+leastspanks+". "
	if (msg1.length() > 2)
		msg+="\n\nDom settings are higher.  "+msg1
	def ret= 0==getSelectedValue(msg, ["OK","Cancel"])
	show("Saving selected options")
	setImage(null)
	if (ret)
	{
		save(properties+"points.finish", -fini)
		if (randommin < leastmin)
			save(properties+"random.min", leastmin)
		if (randommax < x)
			save(properties+"random.max", x)
		if (spanks < leastspanks)
			save(properties+"spank", leastspanks)
	}
	else
		settings(false)
	return ret
}

def dom2std=
{
	setImage(TheOwl())
	def msg="<b>Dom Edition</b>\n\n"
	msg+="Is this game too hard for you? "
	msg+="How do you manage to stand up with no backbone? "
	msg+="If you must return to the Standard Edition, click OK. "
	def ret= 0==getSelectedValue(msg, ["OK","Cancel"])
	show("Saving selected options")
	setImage(null)
	return ret
}

def instructstd={page->
	def msg=""
	def button=3
	switch(page)
	{
	case 1:
		msg+="<b>"+titleplus+"</b> "+version+"\n\n"
		msg+="You will be directed to stand or kneel "
		msg+="in the corner or against the wall or elsewhere. "
		msg+="Some of the challenges use positions other than standing or kneeling. "
		msg+="You are to remain as directed until the alarm rings. "
		msg+="You are not allowed to position yourself where you can see "
		msg+="any kind of clock or timing device.\n\n"
		msg+="The Standard Edition is intended to be a challenge to maintain "
		msg+="the assigned position. "
		if (optenh)
			msg+="The Enhanced Edition makes it slightly harder. "
		msg+="If you would prefer a more Dominant / Sumissive game, click Config, "
		msg+="then click Options and set the Dom option to Yes.\n\n"
		msg+="Some positions are significantly harder to maintain than others.\n\n"
		msg+="Your assigned position is described in the text. "
		msg+="This may or may not match the picture.\n\n"
		button=prevnext(msg, false, true, "Exit Instructions")
		break
	case 2:
		msg+="The time will be selected, in seconds, between "
		msg+=unit(randommin,"minute","minutes")+" (i.e. "+(60*randommin)+" seconds) and "
		msg+=unit(randommax,"minute","minutes")+" (i.e. "+(60*randommax)+" seconds). "
		msg+="You will not be told the selected time until the time expires.\n\n"
		msg+="Unless the directions specify no motion, you are allowed to move. "
		msg+="However, any motion must not violate what is described in the text.\n\n"
		msg+="If a paragraph begins with the word First, "
		msg+="that paragraph is to be done before pressing the Begin button. "
		msg+="This will only occur if you have turned on the Enhanced Option "
		msg+="(described under Config Options).\n\n"
		msg+="You should get into position as quickly as possible "
		msg+="after you press the Begin button.\n\n"
		msg+="If you are unable to maintain the position, press the Failed button. "
		msg+="When the time is up, the button will change to two buttons: "
		msg+="one for Failed and one for Succeeded.\n\n"
		button=prevnext(msg, true, true, "Exit Instructions")
		break
	case 3:
		msg+="The penalty for failure is "+spanks+" spanks -- done in the nude. "
		msg+="Plus, you must do a new randomly selected position. "
		if (percent > 0)
		{
			msg+="For each retry, the time will be increased by "
			msg+=percent+" percent and the number of spanks will be increased by "
			msg+=percent+" percent."
		}
		msg+="\n\nTo make this game fun for people with different desires, "
		msg+="the user may set Options to change the rules of the game. "
		msg+="Config (on screen after exiting instructions) may be used "
		msg+="to change the Options, adjust the spanking implement, "
		msg+="time, number of spanks and percent increase for failure.\n\n"
		msg+="You will need a spanking implement"
		if (imprandom)
			msg+=" which will be selected at random from the implements you posess. "
		else
			msg+=":	"+impdefault+". "
		msg+="But, this is only needed if you fail. "
		msg+="Other objects that may be needed should be available "
		msg+="in a typical house or apartment. "
		button=prevnext(msg, true, false, "Exit Instructions")
		break
	}
	return button
}

def instructdom={page->
	def msg=""
	def button=3
	if (readme < page)
		readme=page
	switch(page)
	{
	case 1:
		msg+="<b>"+titleplus+"</b> "+version+"\n\n"
		msg+="You will be directed to stand or kneel "
		msg+="in the corner or against the wall or elsewhere. "
		msg+="Some of the challenges use positions other than standing or kneeling. "
		msg+="You are to remain as directed until the alarm rings. "
		msg+="It is cheating to position yourself where you can see "
		msg+="any kind of clock or timing device.\n\n"
		msg+="The Dom Edition is a Dominant / Sumissive game. All directions must be followed. "
		msg+="Quitting is not allowed. "
		msg+="If you are too weak to handle this, click Config, "
		msg+="then click Options and set the Dom option to No.\n\n"
		msg+="You should be able to handle all positions, "
		msg+="no matter how hard they are to maintain.\n\n"
		msg+="Your assigned position is described in the text "
		msg+="which is sometimes more creative than the available good pictures. "
		msg+="You will accept that the text may or may not match the picture.\n\n"
		button=prevnext(msg, false, true, "Exit Instructions")
		break
	case 2:
		msg+="The time will be selected, in seconds, between "
		msg+=unit(randommin,"minute","minutes")+" (i.e. "+(60*randommin)+" seconds) and "
		msg+=unit(randommax,"minute","minutes")+" (i.e. "+(60*randommax)+" seconds). "
		msg+="You will not be told the selected time until the time expires.\n\n"
		msg+="Unless the directions specify no motion, you are allowed to move. "
		msg+="(This rule was added for those that are not very good submissives.) "
		msg+="Any motion must not violate what is described in the text.\n\n"
		msg+="If a paragraph begins with the word First, "
		msg+="that paragraph is to be done before pressing the Begin button. "
		msg+="This will only occur if you have turned on the "
		if (optenh)
			msg+="Enhanced Option (described under Config Options).\n\n"
		else
		{
			msg+="Enhanced Option. If you are a good Submissive, "
			msg+="when done with the instructions, you should "
			msg+="click Config, then click Options and set Enhanced to Yes.\n\n"
		}
		msg+="You should get into position as quickly as possible "
		msg+="after you press the Begin button.\n\n"
		msg+="If you are unable to maintain the position, "
		msg+="you are weak and must press the Failed button. "
		msg+="When the time is up, the button will change to two buttons: "
		msg+="one for Failed and one for Succeeded.\n\n"
		button=prevnext(msg, true, true, "Exit Instructions")
		break
	case 3:
		msg+="The penalty for failure is "+spanks+" spanks -- done in the nude. "
		msg+="Plus, you must do a new randomly selected position. "
		if (percent > 0)
		{
			msg+="For each retry, the time will be increased by "
			msg+=percent+" percent and the number of spanks will be increased by "
			msg+=percent+" percent."
		}
		msg+="\n\nTo make this game fun for people who are weaker than you, "
		msg+="the user may set Options to change the rules of the game. "
		msg+="Config (on screen after exiting instructions) may be used "
		msg+="to change the Options, adjust the spanking implement, "
		msg+="time, number of spanks and percent increase for failure.\n\n"
		msg+="You will need a spanking implement"
		if (imprandom)
			msg+=" which will be selected at random from the implements you posess. "
		else
			msg+=":	"+impdefault+". "
		msg+="But, this is only needed if you fail. "
		msg+="Other objects that may be needed should be available "
		msg+="in a typical house or apartment. "
 		readme=99
		button=prevnext(msg, true, false, "Exit Instructions")
		break
	}
	return button
}

def optconfigstd=
{
//	def options=optplus | optrep | optenh
	def options=optrep | optenh
	def msg="<b>Options</b>\n\n"
	msg+="This game may be played in different ways by setting these options on or off. "
	msg+="The Standard game is with all options off.\n\n"
//	msg+="<b>Plus</b> "
//	msg+=options ? (" is "+(optplus ? "ON" : "OFF")) : " "
//	msg+=" - The Standard game includes some difficult positions. "
//	msg+="But, a few very difficult positions are excluded unless this option is on.\n\n"
	msg+="<b>Repeat Option</b> "
	msg+=options ? (" is "+(optrep ? "ON" : "OFF")) : " "
	msg+=" - This option will cause any position that "
	msg+="you fail to maintain to be repeated a few games later.\n\n"
	msg+="<b>Enhanced Option</b> "
	msg+=options ? (" is "+(optenh ? "ON" : "OFF")) : " "
	msg+=" - This option will cause you to be given "
	msg+="an additional task to do while holding the assigned position. "
	msg+="When selected, a list of enhancements with a check box for each will be displayed. "
	msg+="Note that turning off an enhancement may turn off multiple variations.\n\n"
	msg+="<b>Dom Option</b> "
	msg+=options ? (" is "+(optdom ? "ON" : "OFF")) : " "
	msg+=" - The standard edition of this game is a simple challenge to hold an assigned position. "
	msg+="The Dom option makes this more of a Dominant / Submissive game.\n\n"
	msg+=options ? " " : "All options are OFF."
	return msg
}

def optconfigdom=
{
	def options=(!optrep) | (!optenh)
	def msg="<b>Options</b>\n\n"
	msg+="This game may be played in different ways by setting these options on or off. "
	msg+="The Standard game, for people without a backbone, is with all options off.\n\n"
	msg+="<b>Repeat Option</b> "
	msg+=options ? (" is "+(optrep ? "ON" : "OFF")) : " "
	msg+=" - This option will cause any position that "
	msg+="you fail to maintain to be repeated a few games later.\n\n"
	msg+="<b>Enhanced Option</b> "
	msg+=options ? (" is "+(optenh ? "ON" : "OFF")) : " "
	msg+=" - This option will cause you to be given "
	msg+="an additional task to do while holding the assigned position. "
	msg+="When selected, a list of enhancements with a check box for each will be displayed. "
	msg+="Note that turning off an enhancement may turn off multiple variations.\n\n"
	msg+="<b>Dom Option</b> "
	msg+=options ? (" is "+(optdom ? "ON" : "OFF")) : " "
	msg+=" - The standard edition of this game is a simple challenge to hold an assigned position. "
	msg+="The Dom option makes this more of a Dominant / Submissive game.\n\n"
	msg+=options ? "You should set all options to ON." : "All options are ON."
	return msg
}

def askerlow=getRandom(2)
def askerhigh=getRandom(2)

def asker2=
{msg1, curval, minval, maxval, defval ->
	if (!optdom)
		return asker(msg1, curval, minval, maxval, defval)
	def msg=msg1+"\n"
	if (curval < defval)
	{
		if (askerlow == 0)
			msg+="Your value is less than the default of "+defval+"."
		else
			msg+="Default value is "+defval+", but you can set it higher."
		askerlow=1-askerlow
	}
	else
	{
		if (curval != defval)
			msg+="Default value is "+defval+". "
		if (askerhigh == 0)
			msg+="You should always increase the value."
		else
			msg+="Bigger is better."
		askerhigh=1-askerhigh
	}
	def ans=atleast(msg, curval, minval, maxval)
	return ans
}

def startdom={
	def msg=""
	if (readme < 99)
	{
		setImage(domimagefile)
		msg+="You were directed to read the instructions. "
		if (readme == 0)
			msg+="You must do as you are told."
		else
			msg+="You were not directed to just read part of the instructions."
		show(msg)
		showButton("I will read the Instructions")
		return false
	}
	def quitter=loadIntegerVal(properties+"quitter",0)
	if (quitter > 0)
	{
		setImage(getlap())
		def why1=loadStringVal(properties+"why","I'm sorry")
		msg+="Quitting is not permitted. "
		msg+="Last time you played, you terminated this game without completing it. "
		msg+="You are owed a spanking. "
		msg+="Remove all of your clothes."
		show(msg)
		showButton("I have removed everything")
		nude=true
		msg=""
		msg+="You will be given only "+unit(spanks,"spank.","spanks.")
		msg+=" You probably deserve more than this.\n\n"
		msg+="You are to count the spanks out loud.  After the number you must say, out loud:\n"
		msg+=" &nbsp; "+why1
		show(msg)
		showButton("I understand")
		def spanks1=spanks
		if (debugmode)
			spanks1=3
		def myimplement
		if (imprandom)
			myimplement=imp[nimp-1]
		else
			myimplement=impdefault
		spankme(spanks1, myimplement, why1)
		save(properties+"quitter",null)
	}

	setImage(domimagefile)
	def i=pointsfinish+loadIntegerVal(properties+"finish.quit", 0)
	def samplewhy=["I failed to do the dishes","I was late for the meeting",
		"I did not exercise","I was mean to ___ (insert name)","I left the toilet seat up"]
	def mywhy=samplewhy[i%(female ? 4 : 5)]
	for (def running=true ; running ; )
	{
		msg=""
		msg+="You were sent here to correct one of your many faults. "
		msg+="Admit what you have done wrong. "
		msg+="Use words that begin with I such as:\n &nbsp; "
		msg+=mywhy
		whyhere=getString(msg,"")
		if (whyhere.length() > 4)
		{
			if (whyhere.toLowerCase().substring(0,2) == "i ")
				running=false
		}
		if (running)
		{
			showPopup("Declare what you did starting with I -- try again")
			mywhy="I do not pay attention"
		}
	}
	save(properties+"why",whyhere)
	return true
}

///////////////////////////////////////////////////////////////////////////////
// @ 6 required functions + initoptions + initenh + initialize2 + optconfig + configreset

def initoptions=
{
	optplus=0<loadIntegerVal(properties+"opt.plus",0) | optall
	optenh=0<loadIntegerVal(properties+"opt.enhanced",0)
	optrep=0<loadIntegerVal(properties+"opt.repeat",0)
	optrep2=1<loadIntegerVal(properties+"opt.repeat",0)
	titleplus="Stay - "+(optdom ? ((optenh ? "Enhanced" : "")+" Dom") :
			(optenh ? "Enhanced" : "Standard"))+" Edition"
}

def initenh=
{
	cntenh=[]
	cntenhout=0
	enhavail=[0]
	for (def i=0 ; i<=$n ; i++)
		enhanceinfo(i,1)
	def icorner=0
	if (cornerlist[0]%1000 == loadIntegerVal(properties+"repeat0", 0)%1000)
		icorner=1
	for( ; icorner<ncornerlist ; icorner++)
		cornerinfo(icorner,-1)
}

def inithost=
{
	if (!optdom)
		readme=99
	host=[0]
	nhost=1
	yourhost=-1
	initoptions()
	startcorner()
	initenh()
	stay=newdeck(91,98)  // v2.0 - see case46
	nstay=8
	if (likemale)      // v2.0 - 22m is new; old 93 is now 23m; old 97 is now 24m
		stay=joindeck(newdeck(122,124),3,stay,nstay-3)
	yourstay=-1
	def firstcorner=[]
	def i
	for (i=0 ; i<3 ; i++)
		firstcorner[i]=cornerinfo(i,2)
	def morestay=shuffle([46,47,52,53,59,62,64],7)
	if (likemale)
	{
		morestay[0]=140
		morestay[1]=149
		morestay[2]=57
	}
	for (i=0 ; morestay[i] != null ; i++)
	{
		if (morestay[i] != firstcorner[0] & morestay[i] != firstcorner[1] &
			morestay[i] != firstcorner[2])
		{
			stay[nstay]=morestay[i]
			nstay++
		}
	}
	stay=shuffle(stay, nstay)
	def pts=loadIntegerVal(properties+"finish.2", 0)+2*loadIntegerVal(properties+"finish.3", 0)
	if (optdom | pts>8 | loadIntegerVal(properties+"points.finish", 0)>0)
	{
		lap=newdeck(20,33)
		nlap=14
	}
	else
	{
		nlap=6
		lap=shuffle([20,21,22,23,25,30],nlap)
	}
	yourlap=-1
	def last=loadIntegerVal(properties+"lastlap",0)
	if (!optdom)
	{
		if (lap[0] == last)
		{
			lap[0]=lap[nlap-1]
			lap[nlap-1]=last
		}
	}
	initimp(true)
	saysnum=newdeck(0,nsays-1)
	last=loadIntegerVal(properties+"lastsays",99)
	if (saysnum[1] == last)
	{
		saysnum[1]=saysnum[0]
		saysnum[0]=last
	}
	def fini=loadIntegerVal(properties+"finish.1", 0)+loadIntegerVal(properties+"finish.2", 0)+
		loadIntegerVal(properties+"finish.3", 0)
	if (fini%3 == 2 & likefemale & !debugtext)
		likemale=false
}

def initialize2 =
{
	settings(optdom)
	randommin=loadIntegerVal(properties+"random.min", setmin)
	randommax=loadIntegerVal(properties+"random.max", setmax)
	if (randommin > randommax)
		randommin=randommax
	if (randommin < 0)
		randommin=setmin
//	if (randommin < leastmin)
//		randommin=setmin
	if (randommax <= randommin)
		randommax=randommin+leastadd
	spanks=loadIntegerVal(properties+"spank", setspanks)
	if (spanks < leastspanks)
		spanks=setspanks
	percent=loadIntegerVal(properties+"percent", setpercent)
	if (percent < leastpercent)
		percent=setpercent
	initalarm()
}

def initialize=
{
	if (optdom)
		instructimagefile=TheOwl()
	else
		instructimagefile=gethost2()
	configimagefile=gethost2()
	imagefile=gethost2()
	if (optdom)
		domimagefile=gethost2()
	initialize2()
}

def subtitle =
{ loop ->
	if (readme == 99 & loop > 0)
		return "Click Play to start the game."
	def finish=[]
	def n=0
	def pts=0
	pointsfinish=loadIntegerVal(properties+"points.finish", 0)
	for (def i=1 ; i<=3 ; i++)
	{
		finish[i]=loadIntegerVal(properties+"finish."+i, 0)
		pts+=finish[i]
		if (finish[i] > 0)
			n=i
	}
	pointsfinish+=pts
	def quit=loadIntegerVal(properties+"finish.quit", 0)
	def msg=""
	if (pointsfinish < (optdom ? 1 : 2))
		msg="Click Instructions for the game rules.\n\n"
	else
		readme=99
	if (pointsfinish >= 2 | pts >= 2)
	{
		for (def i=1 ; i<=n ; i++)
		{
			msg+="Completed "+unit(finish[i],"time","times")+" in "+unit(i,"try","tries")
			if (i < 3)
				msg+=".\n"
			else
				msg+=" or more.\n"
		}
		if (quit > 0)
			msg+="Gave up "+unit(quit,"time.","times.")
	}
	return msg
}

def instruct={page->
	if (optdom)
		return instructdom(page)
	else
		return instructstd(page)
}

def optconfig=
{
	show(" ")
	def msg
	if (optdom)
		msg=optconfigdom()
	else
		msg=optconfigstd()
	def button=getSelectedValue(msg, ["Change","Exit Config"])
	if (button == 1)
		return
	if (!optrep)
		save(properties+"repeat0",null)
//	def optnames=["Plus","Repeat Option","Enhanced Option","Dom Option"]
//	def pick=[optplus,optrep,optenh,optdom]
	def optnames=["Repeat Option","Enhanced Option","Dom Option"]
	def pick=[optrep,optenh,optdom]
	def optnew=getBooleans("Options - select to turn ON", optnames, pick)
	if (optnew != null)
	{
//		def idom=3
		def irep=0
		def ienh=1
		def idom=2
		def irep2=1
		def enhnew=[]
		show(" ")
		if (optnew[ienh])
		{
			for (def i=0 ; i<nenhkeys ; i++)
				enhnew[i]=loadIntegerVal(properties+"enh."+enhkeys[i],1)>0
			enhnew=getBooleans("Enhancements - select to turn ON", enhnames, enhnew)
		}
		if (optnew[irep] & optnew[ienh])
		{
			msg=""
			msg+="When a position repeats, "
			msg+="should the enhancement automatically repeat with it? "
			if (optdom & optnew[idom])
				msg+="\n\nRepeat Enhancement is the only reasonable answer to this question!"
			irep2=1+getSelectedValue(msg, ["Repeat Enhancement","Re-select Enhancement"])
		}
		def restart=false
		if (optnew[idom] != optdom)
		{
			if (optdom)
				restart=dom2std()
			else
				restart=std2dom()
			if (!restart)
				optnew[idom]=optdom
		}
		show("Settings being saved ...")
		save(properties+"opt.repeat",optnew[irep]?irep2:0)
		save(properties+"opt.enhanced",optnew[ienh]?1:0)
		save(properties+"opt.dom",optnew[idom]?1:0)
		if (optnew[ienh] & enhnew != null)
		{
			for (def i=0 ; i<nenhkeys ; i++)
			{
				if (enhnew[i])
					save(properties+"enh."+enhkeys[i], null)
				else
					save(properties+"enh."+enhkeys[i], 0)
			}
		}
		if (!optnew[ienh])
			save(properties+"enh", null)
		if (restart)
			return 10
		initoptions()
		initenh()
	}
	return 9
}

def configreset = {
	show(" ")
	def msg="<b>Reset</b>\n\n"
	msg+="To reset the minumum time, maximum time, number of spanks and "
	msg+="percentage increase for failures to default values, click Default.\n\n"
	msg+="To reset number of times the game was played & completed "
	msg+="and the number of times played & quit, click Completion.\n\n"
	msg+="To reset both of these, click Both."
	def button=getSelectedValue(msg, ["Default","Completion","Both","Exit Config"])
	if (button == 0 | button == 2)
	{
		save(properties+"percent", null)
		save(properties+"random.min", null)
		save(properties+"random.max", null)
		save(properties+"spank", null)
		initialize2()
	}
	if (button == 1 | button == 2)
	{
		save(properties+"finish.1", null)
		save(properties+"finish.2", null)
		save(properties+"finish.3", null)
		save(properties+"finish.quit", null)
		save(properties+"points.lap", null)  // v2.0 - obsolete
		save(properties+"points.finish", pointsfinish)
	}
}

def config = {
	show(" ")
	def msg="<b>Current Configuration</b>\n\n"
	msg+="This game may be played with variations to the rules. "
	if (optdom & ((!optenh) | (!optrep)))
		msg+="Click Options to turn on the options that are off.\n\n"
	else
		msg+="Click Options for additional details.\n\n"
	msg+="A random time will be selected, in seconds, between "
	msg+=unit(randommin,"minute","minutes")+" and "+unit(randommax,"minute","minutes")+". "
	if (randommin != setmin | randommax != setmax)
		msg+="(Default is to select a time between "+setmin+" minutes and "+setmax+" minutes.) "
	msg+="Failure will be punished with a spanking of "+unit(spanks,"spank","spanks")+". "
	if (spanks != setspanks)
		msg+="(Default is "+setspanks+" spanks.) "
	msg+="After each failure, these 3 numbers will be increased by "+percent+" percent. "
	if (percent != setpercent)
		msg+="(Default is "+setpercent+" percent.) "
	if (optdom)
		msg+="To increase these numbers, click Change Numbers.\n\n"
	else
		msg+="To change these numbers, click Change Numbers.\n\n"
	msg+="Spanking will be done with "
	if (imprandom)
		msg+="an implement selected at random. "
	else
		msg+="a	"+impdefault+". "
	msg+="To change this, click Implements. "
	def button=getSelectedValue(msg, ["Options","Change Numbers","Implements","Reset","Exit Config"])
	if (button == 0)
		return optconfig()
	if (button == 2)
	{
		impconfig()
		return 9
	}
	else if (button == 3)
	{
		configreset()
		return 9
	}
	else if (button == 4)
		return 9

	def oldmin=randommin
	randommin=asker2("Minimum number of minutes?",randommin,leastmin,0,setmin)
	def oldmax=randommax
	randommax=asker2("Maximum number of minutes?",randommax,randommin+leastadd,0,setmax)
	spanks=asker2("Number of spanks for failure?",spanks,leastspanks,0,setspanks)
	percent=asker2("Percentage increase for failures? Do not input the percent symbol.",
		percent,leastpercent,0,setpercent)
	show("Values are being saved")
	save(properties+"percent", percent)
	save(properties+"random.min", randommin)
	save(properties+"random.max", randommax)
	save(properties+"spank", spanks)
	if (randommin > oldmin | randommax > oldmax)
	{
		save(properties+"streak", null)
		save(properties+"streakwl", null)
		save(properties+"streakreset", 1)
	}
	return 9
}

def mainline = {
	streakcheck()
	show(" ")
	if (optdom)
	{
		if (!startdom())
			return 9
	}
	setImage(gethost2())
	testalarm()
	if (debugrand)
	{
		def debmsg="Variables:"
		debmsg+="\nhost "+host
		debmsg+="\nlap "+lap
		debmsg+="\ncornerlist "+cornerlist+" swapped "+kcornerswap
		debmsg+="\nsaysnum "+saysnum
		debmsg+="\nimp "+imp
		debmsg+="\nenhavail "+enhavail
		cntenh[0]="☠"
		debmsg+="\n[wr1="+cntenh[$wr1]+" wr2="+cntenh[$wr2]+" wr3="+cntenh[$wr3]
		debmsg+=" pen="+cntenh[$pen]+" ict="+cntenh[$ict]+"+ icb="+cntenh[$icb]+"+ ice="+cntenh[$ice]
		debmsg+=" cpt="+cntenh[$cpt]+"+ cpb="+cntenh[$cpb]+"+ cp3="+cntenh[$cp3]+"+ cp="+cntenh[$cp]
		debmsg+=" too="+cntenh[$too]+" soa="+cntenh[$soa]+" rub="+cntenh[$rub]
		debmsg+=" bag="+cntenh[$bag]+" dog="+cntenh[$dog]+"] out of "+cntenhout
		getSelectedValue(debmsg, ["Continue"])
	}
	save(properties+"running", true)
	def goodbye2=["Come play again.", "Be sure to come back.",
		"A corner has been reserved for you for next time.", "Come back soon."]
	for (def tries=0 ; ; tries++)
	{
		def status=thecorner(tries)  // status: 0=try again, 1=quit, 2=success
		if (status != 0)
		{
			save(properties+"running", null)
			if (status == 2 & tries == 0)
				streakwon()
			else
				streaknot()
		}
		if (status == 2)
		{
			setImage(exitting())
			if (tries > 2)
				tries=2
			def finishkey=properties+"finish."+(tries+1)
			save(finishkey, loadIntegerVal(finishkey, 0)+1)
			if (optrep & repeat >= 0)
				save(properties+"repeat"+repeat, null)
			def goodbye=["Congratulations!", "That was not very hard, was it?",
				"You made it!", "The fun is in the challenge."]
			def goodbye1=""
			if (tries > 0)
				goodbye1="\nYou may now get dressed. "
			else
			{
				if (unstriptext.length() > 1)
					goodbye1="\nYou may now put "+unstriptext+" back on."
			}
			show(goodbye[getRandom(4)]+goodbye1+"\n\n"+goodbye2[getRandom(4)])
		}
		else if (status == 1)
		{
			setImage(exitting())
			def finishkey=properties+"finish.quit"
			save(finishkey, loadIntegerVal(finishkey, 0)+1)
			save(properties+"running", null)
			def quit=["But the next one might have been easy.",
				"These challenges are not that hard.",
				"Quit after only "+unit(tries+1, "try", "tries")+".",
				"Better luck next time."]
			// Quitters do not get clothes! - Not an oversight!
			show(quit[getRandom(4)]+"\n\n"+goodbye2[getRandom(4)])
		}
		if (status != 0)
		{
			showButton("Goodbye")
			return 19
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Main Library v1.4

def instructloop =
{
	def page=1
	for ( ; ;)
	{
		show(" ")
		if (page <= 0)
			page=0
		def button=instruct(page)
		if (button == 0)      // Previous
			page-=1
		else if (button == 1) // Next
			page+=1
		else if (button == 2) // Exit
			return 9
		else
			return (button-10)
	}
}

def welcome =
{
	inithost()
	if (loadBooleanVal(properties+"running", false))
	{
		def quit=loadIntegerVal(properties+"finish.quit", 0)
		quit++
		save(properties+"finish.quit", quit)
		save(properties+"running", null)
		streaklost()
	}
	instructimagefile=gethost()	// loc 0
	configimagefile=gethost()	// loc 1
	imagefile=gethost()		// loc 2
	initialize()
	show(" ")
	setImage(imagefile)
	def msg="<font size=20 color=#0000ff><b>"+titleplus+"</b></font>\n\n\n"
	def nextbut=9
	for (def loop=0 ; ; loop++)
	{
		def button
		if (nextbut == 9)
		{
			if (loop > 0)
				setImage(imagefile)
			def submsg=subtitle(loop)+"\n"
			button=getSelectedValue(msg+submsg, ["Instructions", "Play", "Config"])
		}
		else if (nextbut > 9)
			return (nextbut-10)
		else
			button=nextbut
		if (button== 0)
		{
			setImage(instructimagefile)
			nextbut=instructloop()
		}
		else if (button== 1)
			nextbut=mainline()
		else if (button== 2)
		{
			setImage(configimagefile)
			nextbut=config()
		}
		else
			nextbut=9
	}
}

// Actual Main Program

def nextbut=welcome()
def button
if (nextbut == 9)
{
	def GamesExists=testexists("scripts/TheSnowyOwl/OwlGames.groovy")
	setImage(TheOwl())
	def owlmsg="What would you like to do next?"
	if (GamesExists)
		button=getSelectedValue(owlmsg+"\n(Owl Games will produce a menu of selected Games)",
			["Play Again", "Owl Games", "Different Script", "Exit SexScripts"])
	else
	{
		button=getSelectedValue(owlmsg,
			["Play Again", "Different Script", "Exit SexScripts"])
		if (button > 0)
			button++
	}
}
else
	button=nextbut
switch(button)
{
case 0:
	return (rerun)
case 1:
	return ("TheSnowyOwl/OwlGames")
case 2:
	show("Use menu to choose and launch a script.")
	return null
case 3:
	exit()
}

///////////////////////////////////////////////////////////////////////////////
